package cn.iocoder.yudao.module.pms.service.iotdailyreporttemplate;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.iotdailyreporttemplate.vo.IotDailyReportTemplatePageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotdailyreporttemplate.vo.IotDailyReportTemplateSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotdailyreporttemplate.IotDailyReportTemplateDO;
import cn.iocoder.yudao.module.pms.dal.mysql.iotdailyreporttemplate.IotDailyReportTemplateMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.IOT_DAILY_REPORT_TEMPLATE_NOT_EXISTS;

/**
 * 生产日报属性模板 Service 实现类
 *
 * @author 超级管理员
 */
@Service
@Validated
public class IotDailyReportTemplateServiceImpl implements IotDailyReportTemplateService {

    @Resource
    private IotDailyReportTemplateMapper iotDailyReportTemplateMapper;

    @Override
    public Long createIotDailyReportTemplate(IotDailyReportTemplateSaveReqVO createReqVO) {
        // 插入
        IotDailyReportTemplateDO iotDailyReportTemplate = BeanUtils.toBean(createReqVO, IotDailyReportTemplateDO.class);
        iotDailyReportTemplateMapper.insert(iotDailyReportTemplate);
        // 返回
        return iotDailyReportTemplate.getId();
    }

    @Override
    public void updateIotDailyReportTemplate(IotDailyReportTemplateSaveReqVO updateReqVO) {
        // 校验存在
        validateIotDailyReportTemplateExists(updateReqVO.getId());
        // 更新
        IotDailyReportTemplateDO updateObj = BeanUtils.toBean(updateReqVO, IotDailyReportTemplateDO.class);
        iotDailyReportTemplateMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotDailyReportTemplate(Long id) {
        // 校验存在
        validateIotDailyReportTemplateExists(id);
        // 删除
        iotDailyReportTemplateMapper.deleteById(id);
    }

    private void validateIotDailyReportTemplateExists(Long id) {
        if (iotDailyReportTemplateMapper.selectById(id) == null) {
            throw exception(IOT_DAILY_REPORT_TEMPLATE_NOT_EXISTS);
        }
    }

    @Override
    public IotDailyReportTemplateDO getIotDailyReportTemplate(Long id) {
        return iotDailyReportTemplateMapper.selectById(id);
    }

    @Override
    public PageResult<IotDailyReportTemplateDO> getIotDailyReportTemplatePage(IotDailyReportTemplatePageReqVO pageReqVO) {
        return iotDailyReportTemplateMapper.selectPage(pageReqVO);
    }

}